<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/barycent.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>barycent.c</h1><a href="barycent_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">/*</span>
<a name="l00025"></a>00025 <span class="comment">  $Id: barycent.c 3014 2010-03-26 17:27:32Z scholz $</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;petscblaslapack.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">/*</span>
<a name="l00032"></a>00032 <span class="comment">  derived from petsc-2.2.1/include/petscblaslapack.h</span>
<a name="l00033"></a>00033 <span class="comment">*/</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#if !defined(PETSC_USE_COMPLEX)</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="preprocessor">#if defined(PETSC_USES_FORTRAN_SINGLE)</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#define DGESV   SGESV</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a>00041 <span class="preprocessor">#if defined(PETSC_USE_SINGLE)</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="preprocessor">#if defined(PETSC_HAVE_FORTRAN_UNDERSCORE) || defined(PETSC_BLASLAPACK_F2C)</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ sgesv_</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#elif defined(PETSC_HAVE_FORTRAN_CAPS)</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ SGESV</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ sgesv</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="preprocessor">#else</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>
<a name="l00053"></a>00053 <span class="preprocessor">#if defined(PETSC_HAVE_FORTRAN_UNDERSCORE) || defined(PETSC_BLASLAPACK_F2C)</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ dgesv_</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#elif defined(PETSC_HAVE_FORTRAN_CAPS)</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ DGESV</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00058"></a><a class="code" href="barycent_8c.html#ad0a1524c4a01bb63f99a577d30382c78">00058</a> <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ dgesv</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>
<a name="l00061"></a>00061 <span class="preprocessor">#endif</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>
<a name="l00063"></a>00063 <span class="preprocessor">#else</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065 <span class="preprocessor">#if defined(PETSC_USES_FORTRAN_SINGLE)</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span><span class="preprocessor">#define ZGESV  CGESV</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>
<a name="l00069"></a>00069 <span class="preprocessor">#if defined(PETSC_HAVE_FORTRAN_UNDERSCORE) || defined(PETSC_BLASLAPACK_F2C)</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ zgesv_</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span><span class="preprocessor">#elif defined(PETSC_HAVE_FORTRAN_CAPS)</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ ZGESV</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span><span class="preprocessor">#define LAgesv_ zgesv</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>
<a name="l00077"></a>00077 <span class="preprocessor">#endif</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>
<a name="l00079"></a>00079 EXTERN_C_BEGIN
<a name="l00080"></a>00080 EXTERN <span class="keywordtype">void</span>      <a class="code" href="barycent_8c.html#ad0a1524c4a01bb63f99a577d30382c78">LAgesv_</a>(<span class="keyword">const</span> <a class="code" href="griddata_8h.html#a32a4e1dd07864f1ebecfd23654aff9c8">PetscBLASInt</a>*, <span class="keyword">const</span> <a class="code" href="griddata_8h.html#a32a4e1dd07864f1ebecfd23654aff9c8">PetscBLASInt</a>*, PetscScalar*, <span class="keyword">const</span> <a class="code" href="griddata_8h.html#a32a4e1dd07864f1ebecfd23654aff9c8">PetscBLASInt</a>*, <a class="code" href="griddata_8h.html#a32a4e1dd07864f1ebecfd23654aff9c8">PetscBLASInt</a>*, PetscScalar*, <span class="keyword">const</span> <a class="code" href="griddata_8h.html#a32a4e1dd07864f1ebecfd23654aff9c8">PetscBLASInt</a>*, <a class="code" href="griddata_8h.html#a32a4e1dd07864f1ebecfd23654aff9c8">PetscBLASInt</a>*);
<a name="l00081"></a>00081 EXTERN_C_END
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="comment">/* calculate barycentric coordinates</span>
<a name="l00085"></a>00085 <span class="comment">   info from: 3Ddata.pdf</span>
<a name="l00086"></a>00086 <span class="comment">   Course in4008 - Data Visualization</span>
<a name="l00087"></a>00087 <span class="comment">   http://visualization.tudelft.nl/frits.html</span>
<a name="l00088"></a>00088 <span class="comment">*/</span>
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="util_8h.html#aa40cad73c5d6c5669cc6e211b86e7367">00090</a> <span class="keywordtype">int</span> <a class="code" href="barycent_8c.html#ac3e1493d687d06e1258e781a9fdf5a90">barycent</a>(PetscReal *p,PetscReal *a,PetscReal *b,PetscReal *c,PetscReal *d,PetscReal *bary)
<a name="l00091"></a>00091 {
<a name="l00092"></a>00092   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,p,1,bary,1);
<a name="l00093"></a>00093   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,d,1,bary,1);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">/* assemble tetmat */</span>
<a name="l00096"></a>00096   PetscReal tetmat[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00097"></a>00097   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,a,1,tetmat,1);   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,d,1,tetmat,1);
<a name="l00098"></a>00098   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,b,1,tetmat+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1);  <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,d,1,tetmat+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1);
<a name="l00099"></a>00099   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,c,1,tetmat+2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1);<a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,d,1,tetmat+2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="comment">/* calculate abc=(alpha,beta,gamma) */</span>
<a name="l00102"></a>00102   <span class="keywordtype">int</span> one=1;
<a name="l00103"></a>00103   <span class="keywordtype">int</span> three=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00104"></a>00104   <span class="keywordtype">int</span> ipiv[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00105"></a>00105   <span class="keywordtype">int</span> <a class="code" href="namespacegmshtoucd.html#af68c1546c900f7a17a20835183320d61">info</a>;
<a name="l00106"></a>00106   <a class="code" href="barycent_8c.html#ad0a1524c4a01bb63f99a577d30382c78">LAgesv_</a>(&amp;three,&amp;one,tetmat,&amp;three,ipiv,bary,&amp;three,&amp;info);CHKERRQ(info);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="keywordflow">if</span> (bary[0]&gt;=0.0 &amp;&amp; bary[1]&gt;=0.0 &amp;&amp; bary[2]&gt;=0.0 &amp;&amp;
<a name="l00109"></a>00109       (bary[0]+bary[1]+bary[2])&lt;1.0) {
<a name="l00110"></a>00110     <span class="keywordflow">return</span>(1);
<a name="l00111"></a>00111   }
<a name="l00112"></a>00112   <span class="keywordflow">else</span> {
<a name="l00113"></a>00113     <span class="keywordflow">return</span>(0);
<a name="l00114"></a>00114   }
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

